# -*- coding: utf-8 -*-
# @微信:samequant
# @网站:打板哥网 www.dabange.com 
# @更多源码下载地址: https://dabange.com/download
# @有偿服务：量化入门课程、量化数据爬取、策略代写
# @日期: 2024/3/31

import pandas as pd
from samequant_functions_qmt import Samequant_functions
from miniqmt_functions import Miniqmt_stock
from config import putong_account_1

m_qmt_1 = Miniqmt_stock(account_id=putong_account_1)
# 查询账户资产资金
asset_dict = m_qmt_1.query_asset()
print(asset_dict)

# 查询账户持仓明细
df_pos = m_qmt_1.quert_positions()
# print(df_pos)
# exit()
def zhangting_zhaban_sell(stock_lst=[], buy1_money=10000000):
    if not stock_lst:
        return
    for stock_code in stock_lst:
        symbol = stock_code[0:6]
        # print(symbol)
        # 查实时全推盘口行情
        s_q_1 = Samequant_functions()
        df_quote = s_q_1.get_quote(symbol=symbol)
        df_quote['买一金额'] = df_quote['买一价'] * df_quote['买一量'] * 100
        # print(df_quote)

        df_sell = df_quote[(df_quote['最新价'] == df_quote['涨停价']) & (df_quote['买一金额'] < buy1_money)]
        # print(df_sell)

        if not df_sell.empty:
            for i in df_sell.index:
                stock_name = df_sell.loc[i, '证券名称']
                buy1_je = df_sell.loc[i, '买一金额']
                print(f'{stock_name} {stock_code}的涨停封单金额为{buy1_je}，小于{buy1_money}， 触发炸板前主动卖出！')
                # 卖出下单, 不填卖出数量时默认满仓卖出 （注意：模拟账号，周末可能无法委托）
                m_qmt_1.order_sell(stock_code=stock_code, price_type='买五价')


if __name__ == '__main__':
    """
    跟踪封单金额，炸板前主动卖出，代码实现逻辑：
    
    1.获取目标个股盘口行情、计算目标个股的涨停价（与同花顺、通达信、东方财富一致）、买一盘口金额（封单金额）
    2.判断是否已经封板（最新价=涨停价）
    3.当前的封单金额小于设定的金额。 
    4.循环运行，判断是否符合条件，符合条件就触发卖出下单。
    """
    zhangting_zhaban_sell(stock_lst=['000545.SZ'], buy1_money=3e+7)
